@ Copyright (c) 2003, Torlus <greg@heliscar.com>
@ see LICENCE.txt for further details

  .GLOBAL Animate
  .GLOBAL TransformVertices
  
	.section	.iwram,"ax",%progbits
	.arm
	.align
	.TEXT

@void Animate(vertex *first_vertex, u32 count, s32 *first_joint)
Animate:
  stmfd	sp!, {v1-v7,fp,ip,lr}            @ push registers we will corrupt

Animate_Loop:

  ldmia   a1!, {a4,v1-v3}          @ reads bone and rel[0..2]
  
  cmp     a4, #0                @ if bone = -1, abs[] = rel[]
  stmltia a1!, {v1-v3}
  blt     Animate_Loop_End

  add     a4, a3, a4, lsl #6    @ a4 points on first_joint + (bone * 16 * 4o)

  ldmia   a4!, {v4-v7}          @ reads mat[0..3]
  
  mul     fp, v1, v4            @ vec[0] * mat[0]
  mul     ip, v1, v5            @ vec[0] * mat[1]
  mul     lr, v1, v6            @ vec[0] * mat[2]

  ldmia   a4!, {v4-v7}          @ reads mat[4..7]

  mla     fp, v2, v4, fp        @ += vec[1] * mat[4]
  mla     ip, v2, v5, ip        @ += vec[1] * mat[5]
  mla     lr, v2, v6, lr        @ += vec[1] * mat[6]

  ldmia   a4!, {v4-v7}          @ reads mat[8..11]

  mla     fp, v3, v4, fp        @ += vec[3] * mat[8]
  mla     ip, v3, v5, ip        @ += vec[3] * mat[9]
  mla     lr, v3, v6, lr        @ += vec[3] * mat[10]

  mov     fp, fp, asr #8
  mov     ip, ip, asr #8
  mov     lr, lr, asr #8

  ldmia   a4!, {v4-v6}          @ reads mat[12..14]
  
  add     fp, fp, v4
  add     ip, ip, v5
  add     lr, lr, v6

  stmia   a1!, {fp,ip,lr}       @ store in abs[]
  
Animate_Loop_End:
  add   a1, a1, #(4*4)        @ skip Sx,Sy,u,v

  sub   a2, a2, #1
  cmp   a2, #0
  bgt   Animate_Loop

  ldmfd	sp!, {v1-v7,fp,ip,lr}            @ push registers we will corrupt
  bx    lr


@void TransformVertices(vertex *first_vertex, u32 count, s32 *mat)
TransformVertices:
  stmfd	sp!, {v1-v7,fp,ip,lr}            @ pop registers

  add     a1, a1, #(4*4) @ skips bone, rel[0..2]

TransformVertices_Loop:

  ldmia   a1, {v1-v3}         @ reads abs[0..2]
  mov     a4, a3

  ldmia   a4!, {v4-v7}          @ reads mat[0..3]

  mul     fp, v1, v4            @ vec[0] * mat[0]
  mul     ip, v1, v5            @ vec[0] * mat[1]
  mul     lr, v1, v6            @ vec[0] * mat[2]

  ldmia   a4!, {v4-v7}          @ reads mat[4..7]

  mla     fp, v2, v4, fp        @ += vec[1] * mat[4]
  mla     ip, v2, v5, ip        @ += vec[1] * mat[5]
  mla     lr, v2, v6, lr        @ += vec[1] * mat[6]

  ldmia   a4!, {v4-v7}          @ reads mat[8..11]

  mla     fp, v3, v4, fp        @ += vec[3] * mat[8]
  mla     ip, v3, v5, ip        @ += vec[3] * mat[9]
  mla     lr, v3, v6, lr        @ += vec[3] * mat[10]

  mov     fp, fp, asr #8
  mov     ip, ip, asr #8
  mov     lr, lr, asr #8

  ldmia   a4, {v4-v6}          @ reads mat[12..14]

  add     fp, fp, v4
  add     ip, ip, v5
  add     lr, lr, v6

  stmia   a1!, {fp,ip,lr}     @ store in abs[]
  add   a1, a1, #(8*4)        @ skip Sx,Sy,u,v,bone,rel[0..2]

  sub   a2, a2, #1
  cmp   a2, #0
  bgt   TransformVertices_Loop

  ldmfd	sp!, {v1-v7,fp,ip,lr}            @ pop registers
  bx    lr

	.pool

	.END

