// Copyright (c) 2003, Torlus <greg@heliscar.com>
// see LICENCE.txt for further details

#ifndef __ENG_TYPE_H__
#define __ENG_TYPE_H__

#include "basetype.h"

// Vertex storage class
typedef struct {
  s32 bone;	  // bone index
  s32 rel[3];   // relative coordinates of the vertex
  s32 abs[3];      // absolute coordinates of the vertex
  s32 Sy,Sx;      // screen coordinates after Perspective
  s32 u,v;        // texture coordinates
} vertex;

// Triangle storage class
typedef struct {
  u16 dspinfo;   // texture index 
  u16 v[3];	// vertices indices
} triangle;

typedef struct {
  s32 mat[16];	// matrix for transformation acording to Euler's coordinates
} joint;

// The two following typedefs are not used
// That's a proposal for what may be a higher-level API

// Mesh storage class
typedef struct {
  u16 visible;	  // visible flag
  u16 triCount;   // number of triangles in the mesh
  triangle *first_triangle;  // pointer to first triangle 

  u32 jointCount;  // number of joints of the skeleton
  s32 *jointParent;  // pointer to joints' parents indices
  joint *base_first_joint; // pointer to first joint of the base skeleton
} mesh;

// Animation storage class
typedef struct {
  mesh *anim_mesh;	// pointer to mesh 
  joint *anim_first_joint; // pointer to anim's first frame's first joint
  u16 frameCount; // number of frames of the animation
  u16 currentFrame; // stores the current frame of the animation
} animation;

#endif // __ENG_TYPE_H__
