// Copyright (c) 2003, Torlus <greg@heliscar.com>
// see LICENCE.txt for further details

#ifndef __ENGINE_H__
#define __ENGINE_H__

#include "eng_type.h"

// useful macro, that plots to screen buffer
#ifdef GBA3DS_MODE4
#define Plot(x, y, c) VideoBuffer[(y)*120+(x)] = c;
#endif

#ifdef GBA3DS_MODE3
#define Plot(x, y, c) ScreenBuffer[(y)*240+(x)] = c;
#endif

#ifdef GBA3DS_MODE5
#define Plot(x, y, c) VideoBuffer[(x)*160+(y)] = c;
#endif

// Structure used for scanline drawing
typedef struct {
  s32 Sx,z,u,v;
} edgeStruct;

// Some consts

#ifdef GBA3DS_MODE4
#define WIDTH 240
#define HEIGHT 160
#endif

#ifdef GBA3DS_MODE3
#define WIDTH 240
#define HEIGHT 160
#endif

#ifdef GBA3DS_MODE5
#define WIDTH 160
#define HEIGHT 128
#endif

extern edgeStruct EdgeLeft[HEIGHT];
extern edgeStruct EdgeRight[HEIGHT];

// The Z-Buffer
extern u16 ZBuffer[HEIGHT*WIDTH];

#ifdef GBA3DS_MODE3
// The Screen Buffer for Mode 3
extern u16 ScreenBuffer[HEIGHT*WIDTH];
#else
// No screen buffer
#endif

// Engine functions

// Engine ASM functions
extern void Animate(vertex *first_vertex, u32 count, s32 *first_joint);
extern void TransformVertices(vertex *first_vertex, u32 count, s32 *matrix);
extern void Fill(void *addr,s32 val,u32 count);
extern void Perspective(vertex *first_vertex,u32 count);
extern void Draw(triangle *tri, vertex *first_vertex, u16 **texture, u32 count);

#endif

