// Copyright (c) 2003, Torlus <greg@heliscar.com>
// see LICENCE.txt for further details

#include "gba.h"
#include "dispcnt.h"
#include "gbautil.h"
#include "dma.h"

// err.. I should move this line elsewhere
u16 *VideoBuffer = FrontBuffer;

IWRAM void WaitForVsync(void)
{
	while(*(volatile u16 *)&REG_VCOUNT != 160) {}
}

IWRAM void Flip(void) {
	
	if(REG_DISPCNT & BACKBUFFER) {
		REG_DISPCNT &= ~BACKBUFFER; //flip to front
		VideoBuffer = BackBuffer; //draw to back
	} else {
		REG_DISPCNT |= BACKBUFFER;   //flip to back
		VideoBuffer = FrontBuffer;  //draw to front
	}
}


// DMA channel 3
IWRAM void DMACopy(void *src, void *dest, u32 count, u32 mode) {
  REG_DM3SAD = (u32)src;
  REG_DM3DAD = (u32)dest;
  REG_DM3CNT = count | mode;

  while(REG_DM3CNT_H & 0x8000);
}
