// Copyright (c) 2003, Torlus <greg@heliscar.com>
// see LICENCE.txt for further details

#ifndef __MATRIX_H__
#define __MATRIX_H__

#include "basetype.h"

extern void matrix_loadIdentity(s32 *mat);
extern void matrix_copy(s32 *src, s32 *dst);

extern void matrix_postMultiply(s32 *m1, s32 *m2, s32 *dst);

extern void matrix_setTranslation( s32 *mat, s32 *trs );
extern void matrix_setInverseTranslation( s32 *mat, s32 *trs );
extern void matrix_setRotation( s32 *mat, s32 *ang );
extern void matrix_setInverseRotation( s32 *mat, s32 *ang );

extern void matrix_inverseRotateVect( s32 *mat, s32 *vec, s32 *vecdst );
extern void matrix_inverseTranslateVect( s32 *mat, s32 *vec, s32 *vecdst );
extern void matrix_transformVertex( s32 *mat, s32 *vec, s32 *vecdst );

#endif // __MATRIX_H__
